#include "spi-c.h"

#define buff_size 100

unsigned char data[buff_size];
FILE *fptr = NULL;
enum { 
	_xtlfreq = 20_000_000,
	_clkfreq = 256_000_000,
	DOWNLOAD_BAUD = 230_400,
	DEBUG_BAUD = DOWNLOAD_BAUD,
};

int my_shift_in(void) {
	int count = 0;									// bytes received
	
	while(_pinr(CS) == 1);							// wait while CS high
	_pinl(MOSI);									// enable smart pin SPI RX
	
	while(_pinr(CS) == 0) {							// while CS is low
		if (_pinr(MOSI))							// if byte waiting
			data[count++] = _rev(_rdpin(MOSI));		// read, fix MSB, save to array
		//	printf("%d\n",data[count-1]);
	}
	
	_pinf(MOSI);									// disable/reset SPI RX
	return count;
}

int main() {
    printf("Main started \n");
	DIRA = 0;
	high(38);
	int m = 0, x = 0, ret = 0, i = 0;
	DIRA |= MOSI ;
	_pinclear(CS);
	m = P_SYNC_RX;
	m |= ((CLK-MOSI) & 0b111) << 24;
	x = 0b0_00000 | (8-1);
	_pinstart(MOSI, m, x, 0);
	while(1) {
		ret = 0;
		ret = my_shift_in();
		//printf("ret : %d\n",ret);
		
		if (ret == buff_size){
		    printf("Break while loop...\n");
			break;    
		}
	}
	
	SD_write();
	return 0;
}

void SD_write() {
	printf("Started new cog print_data()\n");
	mount("/sd", _vfs_open_sdcard());
	
		fptr = fopen("/sd/o.txt", "a");
		
		if (fptr == NULL) {
			printf("File failed to open append.\n");
		} // checking file is present or not
		
		else {
			printf("The file is now opened append.\n");
		}
		
		int data_cnt = fwrite(data, sizeof(char), sizeof(data), fptr);
		//printf("fwrite = %d\n", data_cnt);
		fclose(fptr);
		//printf("fclose in app %d\n", fclose(fptr) );
		memset (data, 0, sizeof(data));
}
